//+------------------------------------------------------------------+
//|                                                    PF_ZigZag.mq4 |
//|                                    www.forex-expert-builders.com |
//|                             http://www.forex-expert-builders.com |
//+------------------------------------------------------------------+
#property copyright "www.forex-expert-builders.com"
#property link      "http://www.forex-expert-builders.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue

extern int ds_periods= 3;

double ZigzagBuffer[];
double HighMapBuffer[];
double LowMapBuffer[];


 bool bFirstBar;   
int lll= 0;
static bool b= true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,ZigzagBuffer);
   SetIndexBuffer(1,HighMapBuffer);
   SetIndexBuffer(2,LowMapBuffer);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   bFirstBar= false;  
   lll= 0; 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
int logId;

void Log(string st)
{
   if(!b && logId>=0)
   {
      FileWrite(logId,   st);
   }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {   
//----

if(!b)
{
logId= FileOpen(WindowExpertName()+"_"+Time[0]+"_"+Symbol()+".log",FILE_WRITE);
Log("Symbol()="+Symbol()+",Period="+Period());
   
}


   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;

   int lastTrend= -1;

   Log(LowMapBuffer[139]);

   for(int i=limit; i>=0; i--) 
   {     
      ZigzagBuffer[i]= 0;
      HighMapBuffer[i]= 0;
      LowMapBuffer[i]= 0;
      double H= High[iHighest(Symbol(),0,MODE_HIGH,ds_periods, i+1)];
      double L= Low[iLowest(Symbol(),0,MODE_LOW,ds_periods, i+1)];
      if(!bFirstBar)
      {         
         if(i<=limit-1)
         {            
            if(High[i]>H)
            {
               LowMapBuffer[limit]= 1;
               ZigzagBuffer[limit]= Low[limit];
               ZigzagBuffer[i]= High[i];
               HighMapBuffer[i]= 1;
               bFirstBar= true;
               lastTrend= OP_SELL;
               Log("HH " + TimeToStr(Time[i]));
            }
            if(Low[i]<L)
            {
               HighMapBuffer[limit]= 1;
               ZigzagBuffer[limit]= High[limit];
               ZigzagBuffer[i]= Low[i];
               LowMapBuffer[i]= 1;
               bFirstBar= true;
               lastTrend= OP_BUY;
               Log("LL " + TimeToStr(Time[i]));
            }
         }
      }   
      else
      {
         Log("start B " + TimeToStr(Time[i])+","+L+","+Low[i]+","+LowMapBuffer[i]+",i="+i+","+LowMapBuffer[139]);
         if(lastTrend==-1)
         {  
            for(int s=i+1;s<Bars;s++)
            {
               if(HighMapBuffer[s]>0 || LowMapBuffer[s]>0)
                  break;
               if(s==Bars)
               {
                  bFirstBar= false;
                  return;
               }
            }
            if(HighMapBuffer[s]>0)
               lastTrend= OP_BUY;
            else
               lastTrend= OP_SELL;
         }      
         
         int forbid= -1;
         if(High[i]>=H && Low[i]<=L)
         {
            if(lastTrend==OP_BUY)
               forbid= OP_BUY;
            if(lastTrend==OP_SELL)   
               forbid= OP_SELL;
         }
         Log("forbid="+forbid);
         if(High[i]>=H)
         if(forbid!=OP_BUY)
         {            
            if(lastTrend==OP_BUY)
            {                              
               s= i+1;
               while(ZigzagBuffer[s]==0 && s<Bars)
                  s++;
               Log("s="+s+",i="+i+",ZigzagBuffer[s]="+ZigzagBuffer[s]+",ZigzagBuffer[i]="+ZigzagBuffer[i]);   
               if(ZigzagBuffer[s]<High[i])
               {
                  HighMapBuffer[s]= 0;
                  Log("Set zero H " + TimeToStr(Time[s]));
                  if(LowMapBuffer[s]>0)
                     ZigzagBuffer[s]= Low[s];
                  else
                     ZigzagBuffer[s]= 0; 
                  ZigzagBuffer[i]= High[i];
                  HighMapBuffer[i]= 1;                 
               }                    
            }
            else
            {
               HighMapBuffer[i]= 1;               
               ZigzagBuffer[i]= High[i];
            }
            lastTrend= OP_BUY;
            Log("H " + TimeToStr(Time[i]));
            
         }
         bool bb[2];
         bb[0]= Low[i]<L;
         bb[1]= forbid!=OP_SELL;
         Log("B " + TimeToStr(Time[i])+","+forbid+","+L+","+Low[i]+","+bb[0]+","+bb[1]+","+LowMapBuffer[i]);
         if(Low[i]<=L)
         if(forbid!=OP_SELL)
         {
            Log("L " + TimeToStr(Time[i])+","+lastTrend);

            if(lastTrend==OP_SELL)
            {                              
               s= i+1;
               while(ZigzagBuffer[s]==0  && s<Bars)
                  s++;
               if(ZigzagBuffer[s]>Low[i])
               {
                  LowMapBuffer[s]= 0;
                  Log("Set zero L " + TimeToStr(Time[s]));
                  if(HighMapBuffer[s]>0)
                     ZigzagBuffer[s]= High[s];
                  else
                     ZigzagBuffer[s]= 0; 
                  ZigzagBuffer[i]= Low[i];  
                  LowMapBuffer[i]= 1;  
                  Log( "L2 " + TimeToStr(Time[i]));                
               }                  
            }
            else
            {
               LowMapBuffer[i]= 1;               
               ZigzagBuffer[i]= Low[i];
               Log("L 1 " + TimeToStr(Time[i]));
            }
            
            lastTrend= OP_SELL;
         }
         Log( TimeToStr(Time[i]) + "--- " +ZigzagBuffer[i]+","+ZigzagBuffer[i+1]+","+ZigzagBuffer[i+2]+","+LowMapBuffer[i]+","+lastTrend);
      }
   }
   

   if(!b)
{
Log("Closed");
FileClose(logId); 
}
b=true;
//----
   return(0);
  }
//+------------------------------------------------------------------+